// Code generated by mockery v2.53.0. DO NOT EDIT.

package db

import (
	context "context"

	mock "github.com/stretchr/testify/mock"
	models "gitlab.com/infor-cloud/martian-cloud/phobos/phobos-api/internal/models"
)

// MockMetrics is an autogenerated mock type for the Metrics type
type MockMetrics struct {
	mock.Mock
}

// CreateMetric provides a mock function with given fields: ctx, metric
func (_m *MockMetrics) CreateMetric(ctx context.Context, metric *models.Metric) (*models.Metric, error) {
	ret := _m.Called(ctx, metric)

	if len(ret) == 0 {
		panic("no return value specified for CreateMetric")
	}

	var r0 *models.Metric
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *models.Metric) (*models.Metric, error)); ok {
		return rf(ctx, metric)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *models.Metric) *models.Metric); ok {
		r0 = rf(ctx, metric)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*models.Metric)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *models.Metric) error); ok {
		r1 = rf(ctx, metric)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetAggregatedMetricStatistics provides a mock function with given fields: ctx, input
func (_m *MockMetrics) GetAggregatedMetricStatistics(ctx context.Context, input *GetAggregatedMetricsInput) ([]*AggregatedMetric, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetAggregatedMetricStatistics")
	}

	var r0 []*AggregatedMetric
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetAggregatedMetricsInput) ([]*AggregatedMetric, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetAggregatedMetricsInput) []*AggregatedMetric); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]*AggregatedMetric)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetAggregatedMetricsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMetricStatistics provides a mock function with given fields: ctx, input
func (_m *MockMetrics) GetMetricStatistics(ctx context.Context, input *MetricFilter) (*MetricStatistics, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetMetricStatistics")
	}

	var r0 *MetricStatistics
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *MetricFilter) (*MetricStatistics, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *MetricFilter) *MetricStatistics); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*MetricStatistics)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *MetricFilter) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetMetrics provides a mock function with given fields: ctx, input
func (_m *MockMetrics) GetMetrics(ctx context.Context, input *GetMetricsInput) (*MetricsResult, error) {
	ret := _m.Called(ctx, input)

	if len(ret) == 0 {
		panic("no return value specified for GetMetrics")
	}

	var r0 *MetricsResult
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *GetMetricsInput) (*MetricsResult, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *GetMetricsInput) *MetricsResult); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*MetricsResult)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *GetMetricsInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// NewMockMetrics creates a new instance of MockMetrics. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockMetrics(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockMetrics {
	mock := &MockMetrics{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
